%global _hardened_build 1

Summary:            openldap 2.5 alpha build
Name:               openldap25
Version:            2.5.1alpha
Release:            1%{?dist}
License:            BSD
BuildRequires:      gcc, libcom_err-devel
BuildRequires:      openssl-devel, cyrus-sasl-devel
BuildRequires:      libtool-ltdl-devel, heimdal-devel
BuildRequires:		libevent-devel, libargon2-devel
AutoReqProv:        no
URL:                http://www.openldap.org

Source0: ftp://ftp.OpenLDAP.org/pub/OpenLDAP/openldap-release/openldap-%{version}.tgz

Patch0: ITS7790.patch

%description
The openldap 2.5 alpha build

%prep
%setup -n openldap-%{version}
%patch0 -p1

%build
CFLAGS="-O0 -g"; export CFLAGS;
./configure --prefix=/usr/local/openldap25 \
  --with-cyrus-sasl \
  --with-tls=openssl \
  --libexecdir=/usr/local/openldap25/lib \
  --enable-dynamic \
  --enable-slapd \
  --enable-modules \
  --enable-backends=mod \
  --enable-balancer=mod \
    --disable-sql \
    --disable-ndb \
    --disable-perl \
    --disable-wt \
  --enable-overlays=mod \
  --enable-debug \
  --enable-spasswd \
  --enable-crypt
make depend
make DEFINES="-DSLAP_SCHEMA_EXPOSE"
make -C contrib/slapd-modules/autogroup prefix=/usr/local/openldap25 libexecdir=/usr/local/openldap25/lib
make -C contrib/slapd-modules/lastbind prefix=/usr/local/openldap25 libexecdir=/usr/local/openldap25/lib
make -C contrib/slapd-modules/noopsrch prefix=/usr/local/openldap25 libexecdir=/usr/local/openldap25/lib
make -C contrib/slapd-modules/passwd/argon2 prefix=/usr/local/openldap25 libexecdir=/usr/local/openldap25/lib implementation=argon2
make -C contrib/slapd-modules/passwd/pbkdf2 prefix=/usr/local/openldap25 libexecdir=/usr/local/openldap25/lib
make -C contrib/slapd-modules/passwd/sha2 prefix=/usr/local/openldap25 libexecdir=/usr/local/openldap25/lib
make -C contrib/slapd-modules/smbk5pwd prefix=/usr/local/openldap25 libexecdir=/usr/local/openldap25/lib HEIMDAL_INC='-I/usr/include/heimdal' HEIMDAL_LIB='-L/usr/lib64/heimdal -lkrb5 -lkadm5srv'
pushd libraries/liblmdb
export XCFLAGS="$(CFLAGS)"
make prefix=/usr/local/openldap25
popd

%install
make install DESTDIR=%{buildroot} STRIP_OPTS=""
make -C contrib/slapd-modules/autogroup install prefix=/usr/local/openldap25 libexecdir=/usr/local/openldap25/lib DESTDIR=%{buildroot} STRIP_OPTS=""
make -C contrib/slapd-modules/lastbind install prefix=/usr/local/openldap25 libexecdir=/usr/local/openldap25/lib DESTDIR=%{buildroot} STRIP_OPTS=""
make -C contrib/slapd-modules/noopsrch install prefix=/usr/local/openldap25 libexecdir=/usr/local/openldap25/lib DESTDIR=%{buildroot} STRIP_OPTS=""
make -C contrib/slapd-modules/passwd/argon2 prefix=/usr/local/openldap25 libexecdir=/usr/local/openldap25/lib implementation=argon2 DESTDIR=%{buildroot} STRIP_OPTS=""
make -C contrib/slapd-modules/passwd/pbkdf2 install prefix=/usr/local/openldap25 libexecdir=/usr/local/openldap25/lib DESTDIR=%{buildroot} STRIP_OPTS=""
make -C contrib/slapd-modules/passwd/sha2 install prefix=/usr/local/openldap25 libexecdir=/usr/local/openldap25/lib DESTDIR=%{buildroot} STRIP_OPTS=""
make -C contrib/slapd-modules/smbk5pwd install prefix=/usr/local/openldap25 libexecdir=/usr/local/openldap25/lib DESTDIR=%{buildroot} STRIP_OPTS=""

pushd libraries/liblmdb
make install prefix=/usr/local/openldap25 DESTDIR=%{buildroot}
popd

rm -f %{buildroot}/usr/local/openldap25/include/lmdb.h
rm -f %{buildroot}/usr/local/openldap25/lib/liblmdb.{a,so}
rm -f %{buildroot}/usr/local/openldap25/lib/openldap/autogroup.a
rm -f %{buildroot}/usr/local/openldap25/lib/openldap/lastbind.a
rm -f %{buildroot}/usr/local/openldap25/lib/openldap/noopsrch.a
rm -f %{buildroot}/usr/local/openldap25/lib/openldap/pw-argon2.a
rm -f %{buildroot}/usr/local/openldap25/lib/openldap/pw-pbkdf2.a
rm -f %{buildroot}/usr/local/openldap25/lib/openldap/pw-sha2.a
rm -f %{buildroot}/usr/local/openldap25/lib/openldap/smbk5pwd.a
mkdir -p %{buildroot}/usr/local/openldap25/var/openldap-data
mkdir -p %{buildroot}/usr/local/openldap25/var/run
chmod 0755 %{buildroot}/usr/local/openldap25/lib/lib*.so*
chmod 0644 %{buildroot}/usr/local/openldap25/lib/*.la
chmod 0644 %{buildroot}/usr/local/openldap25/lib/openldap/*.la
install -m 0700 -d %{buildroot}/usr/local/openldap25/var/openldap-data
install -m 0755 -d %{buildroot}/usr/local/openldap25/var/run

%package libs
Summary:        openldap Libaries
Requires: openssl-libs >= 1.1.1a, cyrus-sasl-lib >= 2.1.26
AutoReqProv:        no

%description libs
The openldap25-libs package contains the openldap libraries

%package devel
Summary:        openldap Development
Requires: openldap25-libs = %{version}-%{release}
AutoReqProv:        no

%description devel
The openldap25-devel package contains the linking libraries and include files

%package server
Summary:        openldap server binaries
Requires: openldap25-libs = %{version}-%{release}, libargon2 >= 20171227, heimdal-libs >= 7.7.0
Requires: libtool-ltdl
AutoReqProv:        no

%description server
The openldap25-server package contains slapd and its modules

%package clients
Summary:        openldap client binaries
Requires: openldap25-libs = %{version}-%{release}
AutoReqProv:        no

%description clients
The openldap25-clients package contains client tools such as ldapsearch

%files libs
%defattr(-,root,root)
/usr/local/openldap25/etc/openldap/ldap.conf.default
/usr/local/openldap25/lib/*.so.*
/usr/local/openldap25/share/man/man5/ldap.conf.5
/usr/local/openldap25/share/man/man5/ldif.5

%files devel
%defattr(-,root,root)
/usr/local/openldap25/include
/usr/local/openldap25/lib/*.a
/usr/local/openldap25/lib/*.la
/usr/local/openldap25/lib/*.so
/usr/local/openldap25/share/man/man3

%files server
%defattr(-,root,root)
/usr/local/openldap25/bin/mdb_*
/usr/local/openldap25/sbin
/usr/local/openldap25/etc
/usr/local/openldap25/lib/slapd
/usr/local/openldap25/lib/openldap
/usr/local/openldap25/share/man/man1/mdb_*
/usr/local/openldap25/share/man/man5/slap*.5
/usr/local/openldap25/share/man/man5/lload*.5
/usr/local/openldap25/share/man/man8
/usr/local/openldap25/var
%exclude /usr/local/openldap25/etc/openldap/ldap.conf
%exclude /usr/local/openldap25/etc/openldap/ldap.conf.default
%exclude /usr/local/openldap25/etc/openldap/slapd.conf
%exclude /usr/local/openldap25/etc/openldap/slapd.ldif
%exclude /usr/local/openldap25/share/man/man5/ldap.conf.5
%exclude /usr/local/openldap25/share/man/man5/ldif.5

%files clients
%defattr(-,root,root)
/usr/local/openldap25/bin
/usr/local/openldap25/share/man/man1
%exclude /usr/local/openldap25/bin/mdb_*
%exclude /usr/local/openldap25/share/man/man1/mdb_*

%changelog
* Thu Jan 28 2021 Symas Support <support@symas.com>
- initial packaging
